conjunction( 0, every_time,            "every time",            event( )).
conjunction( 1, do_nothing,            "do nothing",            event( a(0)=:=0 )).
conjunction( 2, surveillance,          "surveillance",          event( a(0)=:=3 )).

conjunction( 7, never,                 "never",                 event( event(0)=\=0 )).
conjunction( 8, empty,                 "empty",                 event( ob(17)=\=0, ob(16)=\=0 )).
conjunction( 9, left,                  "left",                  event( a(0)=:=1, m(0)=:=0 )).
conjunction(10, right,                 "right",                 event( a(0)=:=2, m(0)=:=0 )).
conjunction(11, forward,               "forward",               event( a(0)=:=1, m(0)=:=1 )).
conjunction(12, backward,              "backward",              event( a(0)=:=2, m(0)=:=1 )).
conjunction(13, up,                    "up",                    event( a(0)=:=1, m(0)=:=2 )).
conjunction(14, down,                  "down",                  event( a(0)=:=2, m(0)=:=2 )).
conjunction(15, real_move,             "real move",             event( event(14)=:=0, ob(24)=\=0 )).
conjunction(16, fake_move,             "fake move",             event( event(14)=:=0, ob(24)=:=0 )).
conjunction(17, change,                "change",                event( event(15)=:=0 )).
conjunction(20, see_W_see_P_no_see_Un_up, "White Pawn !Unmoved up",  event( a(0)=:=1, m(0)=:=2, ob(25)=\=0, ob(18)=:=0, ob(16)=:=0 )).
conjunction(21, see_W_see_P_see_Un_up,    "White Pawn (Unmoved) up", event( a(0)=:=1, m(0)=:=2, ob(25)=:=0, ob(18)=:=0, ob(16)=:=0 )).
conjunction(22, see_B_see_P_no_see_Un_up, "Black Pawn !Unmoved up",  event( a(0)=:=1, m(0)=:=2, ob(25)=\=0, ob(18)=:=0, ob(17)=:=0 )).
conjunction(23, see_B_see_P_see_Un_up,    "Black Pawn (Unmoved) up", event( a(0)=:=1, m(0)=:=2, ob(25)=:=0, ob(18)=:=0, ob(17)=:=0 )).
conjunction(24, see_Rook_up,   "Rook up",   event( a(0)=:=1, m(0)=:=2, ob(19)=:=0 )).
conjunction(25, see_Knight_up, "Knight up", event( a(0)=:=1, m(0)=:=2, ob(20)=:=0 )).
conjunction(26, see_Bishop_up, "Bishop up", event( a(0)=:=1, m(0)=:=2, ob(21)=:=0 )).
conjunction(27, see_Queen_up,  "Queen up",  event( a(0)=:=1, m(0)=:=2, ob(22)=:=0 )).
conjunction(28, see_King_up,   "King up",   event( a(0)=:=1, m(0)=:=2, ob(23)=:=0 )).

implication(35, then_zero,             "then zero",             event( v(0)=:=0 )).
implication(36, then_x,                "then x",                event( v(0)=:=1 )).
implication(37, then_y,                "then y",                event( v(0)=:=2 )).
implication(38, then_z,                "then z",                event( v(0)=:=3 )).

implication(41, no_left,               "not left",              event( a(0)=\=1, m(0)=:=0 )).
implication(42, no_right,              "not right",             event( a(0)=\=2, m(0)=:=0 )).
implication(43, no_forward,            "not forward",           event( a(0)=\=1, m(0)=:=1 )).
implication(44, no_backward,           "not backward",          event( a(0)=\=2, m(0)=:=1 )).
implication(45, no_up,                 "not up",                event( a(0)=\=1, m(0)=:=2 )).
implication(46, no_down,               "not down",              event( a(0)=\=2, m(0)=:=2 )).
implication(47, if_no_see_W_then_no_up,   "!see W => !up",      event( a(0)=\=1, m(0)=:=2, ob(16)=\=0 )).
implication(48, if_see_W_then_no_down,    "see W => !down",     event( a(0)=\=2, m(0)=:=2, ob(16)=:=0 )).
implication(49, if_no_see_B_then_no_up,   "!see B => !up",      event( a(0)=\=1, m(0)=:=2, ob(17)=\=0 )).
implication(50, if_see_B_then_no_down,    "see B => !down",     event( a(0)=\=2, m(0)=:=2, ob(17)=:=0 )).
implication(51, if_no_empty_then_no_down,     "!empty => !down",     event( a(0)=\=2, m(0)=:=2, event(8)=\=0 )).
implication(52, if_empty_then_no_down,        "empty => !down",      event( a(0)=\=2, m(0)=:=2, event(8)=:=0 )).
implication(53, if_no_empty_then_no_forward,  "!empty => !forward",  event( a(0)=\=1, m(0)=:=1, event(8)=\=0 )).
implication(54, if_no_empty_then_no_backward, "!empty => !backward", event( a(0)=\=2, m(0)=:=1, event(8)=\=0 )).
implication(55, if_no_empty_then_no_left,     "!empty => !left",     event( a(0)=\=1, m(0)=:=0, event(8)=\=0 )).
implication(56, if_no_empty_then_no_right,    "!empty => !right",    event( a(0)=\=2, m(0)=:=0, event(8)=\=0 )).
implication(57, see_Lifted,                   "see Lifted",          event( ob(24)=:=0 )).
implication(58, if_upmost_no_left,            "upmost => !left",     event( a(0)=\=1, m(0)=:=0, m(2)=:=7 )).
implication(59, if_upmost_no_right,           "upmost => !right",    event( a(0)=\=2, m(0)=:=0, m(2)=:=7 )).
implication(60, if_lowermost_no_left,         "lowermost=> !left",   event( a(0)=\=1, m(0)=:=0, m(2)=:=0 )).
implication(61, if_lowermost_no_right,        "lowermost=> !right",  event( a(0)=\=2, m(0)=:=0, m(2)=:=0 )).
implication(62, if_cor_a_then_no_cor_b,       "cor(a) => not cor(b)",   event( cor(0)=\=2, cor(0)=:=1 )).

Event is encode_events_val(Negative, Value, Action, Flag):-
  Event := Negative + 2*(Value + 4*(Action + 4*Flag)).
decode_events_val(Event, Negative, Value, Action, Flag):-
  Negative := Event mod 2,
  Value := (Event//2) mod 4,
  Action := (Event//8) mod 4,
  Flag := Event//32.

% events_val =
%  conjunction
%    1 - true,
%    2 - first semi-step (only with view)
%    4 - second semi-step (everything without view)
%  implication
%    0    - false
%    1    - yes or no
%    2,4  - Value (x, y, z or zero)
%    8,16 - Action (cor or v)
%    32   - Flag (from =>a make =>cor)

encode_cell(Cell, Negative, Value, Type, Atom):-
  Cell := Negative + 2*(Value + G_S*(Type + 10*Atom)).
decode_cell(Cell, Negative, Value, Type, Atom):-
  Negative := Cell mod 2,
  Value := (Cell//2) mod G_S,
  Type := (Cell//G_S//2) mod 10,
  Atom := Cell//10//G_S//2.

% Type is a[]= or a[]* or v[]= or m[]= or ...
% Type[Atom] = Value

fixed_models_data(0, states(3), [],
 [every_time],
 [if_cor_a_then_no_cor_b],
 [link(0, 1, 0), link(1, 2, 0), link(2, 0, 0)],
 [trace(2, 0, 1)]). % 

fixed_models_data(1, states(8), [],
 [left, right],
 [no_left, no_right],
 [link(0, 1, 1), link(1, 2, 1), link(2, 3, 1), link(3, 4, 1), link(4, 5, 1), link(5, 6, 1), link(6, 7, 1),
  link(1, 0, 0), link(2, 1, 0), link(3, 2, 0), link(4, 3, 0), link(5, 4, 0), link(6, 5, 0), link(7, 6, 0)],
 [trace(0, 0, 1), trace(7, 1, 1)]).

fixed_models_data(2, states(8), [],
 [forward, backward],
 [no_forward, no_backward],
 [link(0, 1, 0), link(1, 2, 0), link(2, 3, 0), link(3, 4, 0), link(4, 5, 0), link(5, 6, 0), link(6, 7, 0),
  link(1, 0, 1), link(2, 1, 1), link(3, 2, 1), link(4, 3, 1), link(5, 4, 1), link(6, 5, 1), link(7, 6, 1)],
 [trace(0, 1, 1), trace(7, 0, 1)]).

fixed_models_data(3, states(2), [],
 [up, down],
 [no_up, no_down],
 [link(0, 1, 0), link(1, 0, 1)],
 [trace(0, 1, 1), trace(1, 0, 1)]).

fixed_models_data(4, states(2), [],
 [change],
 [if_no_see_W_then_no_up, if_see_W_then_no_down, if_no_see_B_then_no_up, if_see_B_then_no_down],
 [link(0, 1, 0), link(1, 0, 0)],
 [trace(0, 0, 1), trace(0, 1, 1), trace(1, 2, 1), trace(1, 3, 1)]).

fixed_models_data(7, states(9), [see_W_see_P_no_see_Un_up, down], % white Pawn
 [left, forward, right, backward],
 [no_forward, no_left, if_empty_then_no_down, no_right, no_backward, if_no_empty_then_no_down],
 [link(0, 1, 1), link(1, 0, 3), 
  link(1, 2, 0), link(2, 1, 2), link(3, 1, 0), link(1, 3, 2)],
 [trace(1, 0, 1), trace(2, 0, 1), trace(3, 0, 1),
  trace(0, 1, 1), trace(2, 1, 1),
  trace(2, 2, 1), trace(3, 2, 1),
  trace(0, 3, 1), trace(3, 3, 1),
  trace(0, 4, 1), trace(2, 4, 1), trace(3, 4, 1),
  trace(1, 5, 1)]).

fixed_models_data(8, states(5), [see_W_see_P_see_Un_up, down], % white Pawn (Unmoved)
 [left, forward, right, backward],
 [no_forward, no_left, if_empty_then_no_down, no_right, no_backward, if_no_empty_then_no_down, if_no_empty_then_no_forward],
 [link(0, 1, 1), link(1, 0, 3), link(1, 2, 1), link(2, 1, 3), 
  link(1, 3, 0), link(3, 1, 2), link(4, 1, 0), link(1, 4, 2)],
 [trace(2, 0, 1), trace(3, 0, 1), trace(4, 0, 1),
  trace(0, 1, 1), trace(2, 1, 1), trace(3, 1, 1),
  trace(3, 2, 1), trace(4, 2, 1),
  trace(0, 3, 1), trace(2, 3, 1), trace(4, 3, 1),
  trace(0, 4, 1), trace(3, 4, 1), trace(4, 4, 1),
  trace(1, 5, 1), trace(2, 5, 1),
  trace(1, 6, 1)]).

fixed_models_data(9, states(9), [see_B_see_P_no_see_Un_up, down], % black Pawn
 [left, forward, right, backward],
 [no_forward, no_left, if_empty_then_no_down, no_right, no_backward, if_no_empty_then_no_down],
 [link(0, 1, 3), link(1, 0, 1), 
  link(1, 2, 0), link(2, 1, 2), link(3, 1, 0), link(1, 3, 2)],
 [trace(0, 0, 1), trace(2, 0, 1), trace(3, 0, 1),
  trace(0, 1, 1), trace(2, 1, 1),
  trace(2, 2, 1), trace(3, 2, 1),
  trace(0, 3, 1), trace(3, 3, 1),
  trace(1, 4, 1), trace(2, 4, 1), trace(3, 4, 1),
  trace(1, 5, 1)]).

fixed_models_data(10, states(5), [see_B_see_P_see_Un_up, down], % black Pawn (Unmoved)
 [left, forward, right, backward],
 [no_forward, no_left, if_empty_then_no_down, no_right, no_backward, if_no_empty_then_no_down, if_no_empty_then_no_backward],
 [link(0, 1, 3), link(1, 0, 1), link(1, 2, 3), link(2, 1, 1), 
  link(1, 3, 0), link(3, 1, 2), link(4, 1, 0), link(1, 4, 2)],
 [trace(0, 0, 1), trace(3, 0, 1), trace(4, 0, 1),
  trace(0, 1, 1), trace(2, 1, 1), trace(3, 1, 1),
  trace(3, 2, 1), trace(4, 2, 1),
  trace(0, 3, 1), trace(2, 3, 1), trace(4, 3, 1),
  trace(2, 4, 1), trace(3, 4, 1), trace(4, 4, 1),
  trace(1, 5, 1), trace(2, 5, 1),
  trace(1, 6, 1)]).

fixed_models_data(11, states(5), [see_Rook_up, down], % Rook
 [left, forward, right, backward],
 [no_forward, no_left, see_Lifted, no_right, no_backward, if_no_empty_then_no_left, if_no_empty_then_no_right, if_no_empty_then_no_forward, if_no_empty_then_no_backward],
 [link(1, 1, 3), link(0, 1, 1), link(1, 0, 3), link(2, 2, 1), link(2, 0, 1), link(0, 2, 3), link(3, 3, 2), link(0, 3, 0), link(3, 0, 2), link(4, 4, 0), link(4, 0, 0), link(0, 4, 2)],
 [trace(0, 2, 1), trace(1, 2, 2), trace(2, 2, 2), trace(3, 2, 2), trace(4, 2, 2),
  trace(1, 1, 1), trace(1, 3, 1), trace(2, 1, 1), trace(2, 3, 1),
  trace(3, 0, 1), trace(3, 4, 1), trace(4, 0, 1), trace(4, 4, 1),
  trace(1, 7, 1), trace(2, 8, 1), trace(3, 5, 1), trace(4, 6, 1)]).

fixed_models_data(12, states(17), [see_Knight_up, down], % Knight
 [left, forward, right, backward],
 [no_forward, no_left, no_down, no_right, no_backward],
 [link( 0, 1, 1), link(1,  0, 3), link( 1,  2, 1), link( 2,  1, 3), link( 2,  3, 0), link( 3,  2, 2), link( 4,  2, 0), link( 2,  4, 2),
  link( 5, 0, 1), link(0,  5, 3), link( 6,  5, 1), link( 5,  6, 3), link( 6,  7, 0), link( 7,  6, 2), link( 8,  6, 0), link( 6,  8, 2),
  link( 9, 0, 2), link(0,  9, 0), link(10,  9, 2), link( 9, 10, 0), link(10, 11, 1), link(11, 10, 3), link(12, 10, 1), link(10, 12, 3),
  link(13, 0, 0), link(0, 13, 2), link(14, 13, 0), link(13, 14, 2), link(14, 15, 1), link(15, 14, 3), link(16, 14, 1), link(14, 16, 3)],
 [trace(11, 0, 1), trace( 7, 0, 1), trace( 9, 0, 1), trace(3, 0, 1), trace(2, 0, 1), trace( 8, 0, 1), trace(13, 0, 1), trace( 4, 0, 1), trace(15, 0, 1),
  trace(12, 4, 1), trace( 7, 4, 1), trace( 9, 4, 1), trace(3, 4, 1), trace(6, 4, 1), trace( 8, 4, 1), trace(13, 4, 1), trace( 4, 4, 1), trace(16, 4, 1),
  trace(12, 1, 1), trace(11, 1, 1), trace(10, 1, 1), trace(3, 1, 1), trace(7, 1, 1), trace( 1, 1, 1), trace( 5, 1, 1), trace(15, 1, 1), trace(16, 1, 1),
  trace(12, 3, 1), trace(11, 3, 1), trace(14, 3, 1), trace(4, 3, 1), trace(8, 3, 1), trace( 1, 3, 1), trace( 5, 3, 1), trace(15, 3, 1), trace(16, 3, 1),
  trace( 1, 2, 1), trace( 2, 2, 1), trace( 5, 2, 1), trace(6, 2, 1), trace(9, 2, 1), trace(10, 2, 1), trace(13, 2, 1), trace(14, 2, 1)]).

fixed_models_data(13, states(13), [see_Bishop_up, down], % Bishop
 [left, forward, right, backward],
 [no_forward, no_left, see_Lifted, no_right, no_backward,
  if_upmost_no_left, if_upmost_no_right, if_lowermost_no_left, if_lowermost_no_right, 
  if_no_empty_then_no_left, if_no_empty_then_no_right, no_down],
 [link(0, 1, 0), link(3, 0, 3), link(1, 2, 1), link(2, 1, 0), link(3, 2, 3), link(2, 3, 2),
  link(0, 4, 2), link(6, 0, 3), link(4, 5, 1), link(5, 4, 2), link(6, 5, 3), link(5, 6, 0),
  link(0, 7, 0), link(9, 0, 1), link(7, 8, 3), link(8, 7, 0), link(9, 8, 1), link(8, 9, 2),
  link(0, 10, 2), link(12, 0, 1), link(10, 11, 3), link(11, 10, 2), link(12, 11, 1), link(11, 12, 0)],
 [trace(0, 2, 1), trace(2,  2, 2), trace(5, 2, 2), trace( 8,  2, 2), trace(11, 2, 2),
  trace(0, 0, 1), trace(2,  0, 1), trace(3, 0, 1), trace( 5,  0, 1), trace( 6, 0, 1), trace(7, 0, 1), trace( 8, 0, 1), trace(10, 0, 1), trace(11, 0, 1),
  trace(0, 4, 1), trace(2,  4, 1), trace(1, 4, 1), trace( 5,  4, 1), trace( 4, 4, 1), trace(9, 4, 1), trace( 8, 4, 1), trace(12, 4, 1), trace(11, 4, 1),
  trace(1, 1, 1), trace(3,  1, 1), trace(4, 1, 1), trace( 6,  1, 1), trace( 7, 1, 1), trace(9, 1, 1), trace(10, 1, 1), trace(12, 1, 1),
  trace(1, 3, 1), trace(3,  3, 1), trace(4, 3, 1), trace( 6,  3, 1), trace( 7, 3, 1), trace(9, 3, 1), trace(10, 3, 1), trace(12, 3, 1),
  trace(1, 11, 1), trace(3, 11, 1), trace(4, 11, 1), trace( 6, 11, 1), trace( 7, 11, 1), trace(9, 11, 1), trace(10, 11, 1), trace(12, 11, 1),
  trace(2, 5, 1), trace(5,  6, 1), trace(8, 7, 1), trace(11,  8, 1),
  trace(2, 9, 1), trace(5, 10, 1), trace(8, 9, 1), trace(11, 10, 1)
]).

fixed_models_data(14, states(17), [see_Queen_up, down], % Queen
 [left, forward, right, backward],
 [no_forward, no_left, see_Lifted, no_right, no_backward,
  if_upmost_no_left, if_upmost_no_right, if_lowermost_no_left, if_lowermost_no_right, 
  if_no_empty_then_no_left, if_no_empty_then_no_right, if_no_empty_then_no_forward, if_no_empty_then_no_backward, no_down],
 [link(0, 1, 0), link(3, 0, 3), link(1, 2, 1), link(2, 1, 0), link(3, 2, 3), link(2, 3, 2),
  link(0, 4, 2), link(6, 0, 3), link(4, 5, 1), link(5, 4, 2), link(6, 5, 3), link(5, 6, 0),
  link(0, 7, 0), link(9, 0, 1), link(7, 8, 3), link(8, 7, 0), link(9, 8, 1), link(8, 9, 2),
  link(0, 10, 2), link(12, 0, 1), link(10, 11, 3), link(11, 10, 2), link(12, 11, 1), link(11, 12, 0),
  link(13, 13, 3), link(0, 13, 1), link(13, 0, 3), link(14, 14, 1), link(14, 0, 1), link(0, 14, 3), link(15, 15, 2), link(0, 15, 0), link(15, 0, 2), link(16, 16, 0), link(16, 0, 0), link(0, 16, 2)],
 [trace( 0,  2, 1), trace( 2,  2, 2), trace( 5, 2, 2), trace( 8,  2, 2), trace(11, 2, 2),
  trace( 2,  0, 1), trace( 3,  0, 1), trace( 5, 0, 1), trace( 6,  0, 1), trace( 7, 0, 1), trace(8, 0, 1), trace(10, 0, 1), trace(11, 0, 1),
  trace( 2,  4, 1), trace( 1,  4, 1), trace( 5, 4, 1), trace( 4,  4, 1), trace( 9, 4, 1), trace(8, 4, 1), trace(12, 4, 1), trace(11, 4, 1),
  trace( 1,  1, 1), trace( 3,  1, 1), trace( 4, 1, 1), trace( 6,  1, 1), trace( 7, 1, 1), trace(9, 1, 1), trace(10, 1, 1), trace(12, 1, 1),
  trace( 1,  3, 1), trace( 3,  3, 1), trace( 4, 3, 1), trace( 6,  3, 1), trace( 7, 3, 1), trace(9, 3, 1), trace(10, 3, 1), trace(12, 3, 1),
  trace(1, 13, 1), trace(3, 13, 1), trace(4, 13, 1), trace( 6, 13, 1), trace( 7, 13, 1), trace(9, 13, 1), trace(10, 13, 1), trace(12, 13, 1),
  trace( 2,  5, 1), trace( 5,  6, 1), trace( 8, 7, 1), trace(11,  8, 1),
  trace( 2,  9, 1), trace( 5, 10, 1), trace( 8, 9, 1), trace(11, 10, 1),
  trace(13,  2, 2), trace(14,  2, 2), trace(15, 2, 2), trace(16,  2, 2),
  trace(13,  1, 1), trace(13,  3, 1), trace(14, 1, 1), trace(14,  3, 1),
  trace(15,  0, 1), trace(15,  4, 1), trace(16, 0, 1), trace(16,  4, 1),
  trace(13, 11, 1), trace(14, 12, 1), trace(15, 9, 1), trace(16, 10, 1)]).

fixed_models_data(15, states(9), [see_King_up, down], % King
 [left, forward, right, backward],
 [no_forward, no_left, no_right, no_backward],
 [link(0, 1, 1), link(1, 0, 3), link(2, 0, 1), link(0, 2, 3), link(0, 3, 0), link(3, 0, 2), link(4, 0, 0), link(0, 4, 2),
  link(3, 5, 1), link(5, 3, 3), link(7, 3, 1), link(3, 7, 3), link(1, 5, 0), link(5, 1, 2), link(6, 1, 0), link(1, 6, 2),
  link(4, 6, 1), link(6, 4, 3), link(8, 4, 1), link(4, 8, 3), link(2, 7, 0), link(7, 2, 2), link(8, 2, 0), link(2, 8, 2)],
 [trace(5, 0, 1), trace(1, 0, 1), trace(6, 0, 1), trace(7, 3, 1), trace(2, 3, 1), trace(8, 3, 1),
  trace(5, 1, 1), trace(3, 1, 1), trace(7, 1, 1), trace(6, 2, 1), trace(4, 2, 1), trace(8, 2, 1)]).

fixed_models_data(26, states(0), [],
 [empty, never, fake_move, real_move],
 [],
 [],
 []).

coordinates(3, 0, -1, 1).
coordinates(3, 1, -1, -1).

coordinates(4, 0, 1, 1.5).
coordinates(4, 1, 1, -1.5).

coordinates(7, 0, 0, 0). % white pawn
coordinates(7, 1, 0, -1).
coordinates(7, 2, -1, -1).
coordinates(7, 3, 1, -1).

coordinates(8, 0, 0, 0). % white Pawn (Unmoved)
coordinates(8, 1, 0, -1).
coordinates(8, 2, 0, -2).
coordinates(8, 3, -1, -1).
coordinates(8, 4, 1, -1).

coordinates(9, 0, 0, 0). % black Pawn
coordinates(9, 1, 0, 1).
coordinates(9, 2, -1, 1).
coordinates(9, 3, 1, 1).

coordinates(10, 0, 0, 0). % black Pawn (Unmoved)
coordinates(10, 1, 0, 1).
coordinates(10, 2, 0, 2).
coordinates(10, 3, -1, 1).
coordinates(10, 4, 1, 1).

coordinates(11, 0, 0, 0). % Rook
coordinates(11, 1, 0, -1.5).
coordinates(11, 2, 0, 1.5).
coordinates(11, 3, -1.5, 0).
coordinates(11, 4, 1.5, 0).

coordinates(12, 0, 0, 0). % Knight
coordinates(12, 1, 0, -1).
coordinates(12, 2, 0, -2).
coordinates(12, 3, -1, -2).
coordinates(12, 4, 1, -2).
coordinates(12, 5, 0, 1).
coordinates(12, 6, 0, 2).
coordinates(12, 7, -1, 2).
coordinates(12, 8, 1, 2).
coordinates(12, 9, -1, 0).
coordinates(12, 10, -2, 0).
coordinates(12, 11, -2, -1).
coordinates(12, 12, -2, 1).
coordinates(12, 13, 1, 0).
coordinates(12, 14, 2, 0).
coordinates(12, 15, 2, -1).
coordinates(12, 16, 2, 1).

coordinates(13, 0, 0, 0). % Bishop
coordinates(13, 1, -2, -1).
coordinates(13, 2, -2, -2).
coordinates(13, 3, -1, -2).
coordinates(13, 4, 2, -1).
coordinates(13, 5, 2, -2).
coordinates(13, 6, 1, -2).
coordinates(13, 7, -2, 1).
coordinates(13, 8, -2, 2).
coordinates(13, 9, -1, 2).
coordinates(13, 10, 2, 1).
coordinates(13, 11, 2, 2).
coordinates(13, 12, 1, 2).

coordinates(14, 0, 0, 0). % Queen
coordinates(14, 1, -2, -1).
coordinates(14, 2, -2, -2).
coordinates(14, 3, -1, -2).
coordinates(14, 4, 2, -1).
coordinates(14, 5, 2, -2).
coordinates(14, 6, 1, -2).
coordinates(14, 7, -2, 1).
coordinates(14, 8, -2, 2).
coordinates(14, 9, -1, 2).
coordinates(14, 10, 2, 1).
coordinates(14, 11, 2, 2).
coordinates(14, 12, 1, 2).
coordinates(14, 13, 0, -1.5).
coordinates(14, 14, 0, 1.5).
coordinates(14, 15, -1.5, 0).
coordinates(14, 16, 1.5, 0).

coordinates(15, 0, 0, 0). % King
coordinates(15, 1, 0, -1).
coordinates(15, 2, 0, 1).
coordinates(15, 3, -1, 0).
coordinates(15, 4, 1, 0).
coordinates(15, 5, -1, -1).
coordinates(15, 6, 1, -1).
coordinates(15, 7, -1, 1).
coordinates(15, 8, 1, 1).

memory_rules( "1. ", 5, "  up, here =>", " copy(Lifted)").
memory_rules( "2. ", 5, "down, everywhere =>", " del(Lifted)").
memory_rules( "3. ", 5, "down, here =>", " copy(mem7(0))").
memory_rules( "4. ", 5, "real_move, here =>", " del(Unmoved)").
memory_rules( "",    5, "", "").
memory_rules( "",    5, "", "").
memory_rules( "5. ", 5, "=>", " ob(now) := mem6(here)").

memory_rules( "",    6, "", "").
memory_rules( "",    6, "", "").
memory_rules( "",    6, "", "").
memory_rules( "",    6, "", "").
memory_rules( "6. ", 6, "here=1 =>", " mem7(here) := ob(now)").


make_colors(5):-
  color_text(_, rgb(255,0,0)).
make_colors(7):-
  color_text(_, rgb(255,255,255)),
  color_text_back(_, rgb(0,255,255)).
make_colors(9):-
  color_text(_, rgb(0,0,0)).
make_colors(11):-
  color_text(_, rgb(255,0,0)),
  color_text_back(_, system_color(window)).
make_colors(16):-
  color_text(_, rgb(255,255,255)),
  color_text_back(_, rgb(0,255,255)).
make_colors(17):-
  color_text(_, rgb(0,0,0)).
make_colors(18):-
  color_text(_, rgb(0,0,255)),
  color_text_back(_, rgb(255,255,0)).
make_colors(24):-
  color_text(_, rgb(0,0,0)),
  color_text_back(_, rgb(0,255,0)).
make_colors(26):-
  color_text_back(_, system_color(window)).


face(0, "  ").
face(1, "p ").
face(2, " r").
face(3, " k").
face(4, " b").
face(5, " Q").
face(6, " K").

names(0, "1", "            1, 2, 3", "", "").
names(1, "2", "           Horizontal", "", "").
names(2, "3", "            Vertical", "", "").
names(3, "4", "Lifting Up and Placing Down", "", "").
names(4, "5", "Play with White or with Black", "", "").
names(5, "M", "", "", "").
names(6, "M", "Memory 7 - One Dimension (Lift - Place)", "", "").
names(7, "p", "    Algorithm for white Pawn", "Pawn", "pawn").
names(8, "p", "Algorithm for white Pawn (Unmoved)", "Pawn", "pawn").
names(9, "p", "    Algorithm for black Pawn", "Pawn", "pawn").
names(10, "p", "Algorithm for black Pawn (Unmoved)", "Pawn", "pawn").
names(11, "r", "      Algorithm for Rook", "Rook", "rook").
names(12, "k", "      Algorithm for Knight", "Knight", "knigh").
names(13, "b", "      Algorithm for Bishop", "Bishop", "bishop").
names(14, "Q", "       Algorithm for Queen", "Queen", "queen").
names(15, "K", "       Algorithm for King", "King", "king").
names(16, "W", "          White Colour", "White", "white").
names(17, "B", "           Black Colour", "Black", "black").
names(18, "p", "             Pawn", "Pawn", "pawn").
names(19, "r", "             Rook", "Rook", "rook").
names(20, "k", "             Knight", "Knight", "knight").
names(21, "b", "             Bishop", "Bishop", "bishop").
names(22, "Q", "             Queen", "Queen", "queen").
names(23, "K", "             King", "King", "king").
names(24, "L", "  A Piece is Lifted from Here", "Lifted", " lift").
names(25, "U", "         Unmoved Piece", "Unmoved", "unmov").
names(26, "E", "         Other Events", "Events", "events").

