include("3D Studio.h").


/***************/


world(object, 
 [
   cube([-30, -20, 0], one),
   hand([-20, 10, 0], stretch(0.06)*rotation(x, G_Time/3)),
   square([0, 0, 0], one),
   rainbow([0, 0, 0], one),
   head([10, 0, 0], rotation(z, G_Time))
 ]).

cube(shape, 
 [
  [0, 0, 0], [10, 0, 0], [10, 10, 0], [0, 10, 0], [0, 0, 0],
  [0, 0, 10], [10, 0, 10], [10, 10, 10], [0, 10, 10], [0, 0, 10],
  break, [10, 0, 0], [10, 0, 10],
  break, [0, 10, 0], [0, 10, 10],
  break, [10, 10, 0], [10, 10, 10]
 ]).

square(shape, 
 [
  [0, 0, 0], [10, 0, 0], [10, 10, 0], [0, 10, 0], [0, 0, 0]
 ]).

rainbow(bezier, 
 [
  [0, 0, 0], [15, 0, 0], [15, 10, 0], [0, 10, 0]
 ]).

head(object,
 [
  square([0, 0, 0], one),
  square([10, 0, 0], rotation(z, G_Time))
 ]).

hand(object, % made by Borimira Sirakova 
 [
   finger([0, -45, 0], stretch(1.3)*rotation(y, G_Finger)),
   finger([2, -15, 0], stretch(1.6)*rotation(y, G_Finger)),
   finger([3, 15, 0], stretch(1.5)*rotation(y, G_Finger)),
   finger([0, 45, 0], stretch(1.2)*rotation(y, G_Finger)),
   thumb([-90, -15, 0], stretch(1.3)),
   finger3([-90, 45, 0], stretch(9)),
   finger3([-60, -45, 0], stretch(6))
 ]).

thumb(object, 
 [
   finger([0, 0, 0], rotation(x, 1.2)*rotation(z, 0.8))
 ]).

finger(object, 
 [
   finger3([0, 0, 0], stretch(4)),
   head2([40, 0, 0], rotation(y, G_Finger))
 ]).

finger3(shape, 
 [
  [0, 0, 0], [10, 0, 0]
 ]).

head2(object,
 [
  finger3([0, 0, 0], stretch(2)),
  finger3([20, 0, 0], rotation(y, G_Finger))
 ]).
  

