?-
  File1 is "C:/USA/cgi-bin/dump/u0.dump",
  File2 is "C:/USA/cgi-bin/dump/w0.dump",
  G_Page:= 5,
  G_Separator := 0x1234123412341234,
  G_Max_Differences := 30, % max_integer

  H_File1 := open(File1, "rb"),
  H_File2 := open(File2, "rb"),
  go_to_the_page(H_File1, S1, "first"),
  go_to_the_page(H_File2, S2, "second"),
  write("The page "+G_Page+" starts from "+S1+" and from "+S2+".", in_green), nl,
  G_Num:= -1,
  G_Diff := 0,
  compare_digital_file(H_File1, H_File2),
  nl,
  close(H_File1),
  close(H_File2),
  write("Differences are "+G_Diff, in_blue), nl.

compare_digital_file(H_File1, H_File2):-
  repeat,
  get_if_you_can(H_File1, D1, R1),
  get_if_you_can(H_File2, D2, R2),
  G_Num:=G_Num+1,
  (R1=:=1, R2=:=1, D1=:=D2 ->
    fail
  else (R1+R2<2 ->
    (R1=:=R2 ->
      write("The size of page "+G_Page+" is "+G_Num+".", in_green), nl
    else
      write("n"+G_Num+" : The page "+G_Page+" in the "+(R1=:=0-> "first" else "second")+" file is shorter.", in_red), nl
    )
  else
    G_Diff := G_Diff+1,
    G_Max_Differences >= G_Diff,
    write("n"+G_Num+" : ", in_blue),
    % write(D1+"=\\="+D2+" "), 
    write("0x"+hex_string(D1)+"=\\=0x"+hex_string(D2)), 
    nl, fail
  )).

go_to_the_page(H_File, Start, First):-
  G_Page>0,
  Page:=0,
  Start:=0,
  repeat,
  (R := get(H_File, int32)->
    Start:=Start+1,
    (R=:=G_Separator->
      Page := Page+1,
      (Page =:= G_Page->
        cut(6.5)
      )
    )
  else
    write("Page "+G_Page+" is not in the "+First+" file.", in_red), nl,
    cut(3)
  ),
  fail.
go_to_the_page(H_File, Start, First).

get_if_you_can(File, Data, Return):-
  (Data := get(File, int32), Data =\= G_Separator ->
    Return:=1
  else
    Data:=0,
    Return:=0
  ).
